#include "XmlProlog.h"

#include "XmlAttribute.h"

XmlProlog::XmlProlog(const String& tagName)
    : XmlElement(tagName),
      mVersion(XmlProlog::Version::V1_0),
      mEncoding(XmlProlog::Encoding::UTF8)
{

}

Ptr<XmlProlog> XmlProlog::Create(const String& tagName)
{
    return Ptr<XmlProlog>::create(tagName);
}

XmlProlog::Encoding XmlProlog::getEncoding() const
{
    return mEncoding;
}

XmlProlog::Version XmlProlog::getVersion() const
{
    return mVersion;
}

void XmlProlog::setEncoding(const String& encoding)
{
    if(encoding == "UTF-8")
    {
        mEncoding = XmlProlog::Encoding::UTF8;
    }
}

void XmlProlog::setVersion(const String& version)
{
    if(version == "1.0")
    {
        mVersion = XmlProlog::Version::V1_0;
    }
}

void XmlProlog::update()
{
    if(const auto version = getAttribute("version"))
    {
        setVersion(version->getValue());
    }

    if(const auto encoding = getAttribute("encoding"))
    {
        setEncoding(encoding->getValue());
    }
}
