#pragma once

#include "XmlElement.h"

#include "Pointer.h"
#include "Vector.h"

class XmlProlog : public XmlElement
{
public:
    enum class Version{
        V1_0
    };

    enum class Encoding{
        UTF8
    };

public:
    XmlProlog(const String& tagName);

    static Ptr<XmlProlog> Create(const String& tagName);

    Encoding getEncoding() const;
    Version getVersion() const;

    void setEncoding(const String& encoding);
    void setVersion(const String& version);
    void update();

private:
    Version mVersion;
    Encoding mEncoding;
};